Unit AV15C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAV10_p;

procedure AV15C(N :Integer; CA :Complex; var CX :Array of Complex;
                INCX :Integer; var IERR :Integer);

implementation

procedure AV15C(N :Integer; CA :Complex; var CX :Array of Complex;
                INCX :Integer; var IERR :Integer);
var
I,INCX1,M,MP1,NINCX :Integer;
X :Real;
label
_10,_20,_30,_40,_50,_60,_80;
begin
if ( N  <=  0 ) 
 then goto _60;
IERR  := 0;
INCX1  := Abs(INCX);
X  := 0.0;
if ( INCX  =  1 ) 
 then goto _20;
NINCX  := N*INCX1;
I := 1;
while ( I<=NINCX ) do
 begin
  CX[I-1] := MulC(CA,CX[I-1]);
_10:
  inc(I,INCX1);
 end;
goto _80;
_20:
M  := ((N) Mod (5));
if ( M  =  0 ) 
 then goto _40;
for I:=1 to M do
 begin
  CX[I-1] := MulC(CA,CX[I-1]);
_30:
 end;
if ( N  <  5 ) 
 then goto _80;
_40:
MP1  := M + 1;
I := MP1;
while ( I<=N ) do
 begin
  CX[I-1] := MulC(CA,CX[I-1]);
  CX[I+0] := MulC(CA,CX[I+0]);
  CX[I+1] := MulC(CA,CX[I+1]);
  CX[I+2] := MulC(CA,CX[I+2]);
  CX[I+3] := MulC(CA,CX[I+3]);
_50:
  inc(I,5);
 end;
goto _80;
_60:
IERR  := 65;
UTAV10(IERR,18);
goto _80;
_80:
end;

end.
